package org.stm.rectify.assin.service;

import org.jeecg.common.system.vo.SelectTreeModel;
import org.stm.rectify.assin.entity.StProblemTaskAssin;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.common.exception.JeecgBootException;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.stm.rectify.assin.vo.BatchFpVo;
import org.stm.rectify.assin.vo.ProjectImportAssinVo;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * @Description: 任务分配
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */
public interface IStProblemTaskAssinService extends IService<StProblemTaskAssin> {

	/**根节点父ID的值*/
	public static final String ROOT_PID_VALUE = "0";
	
	/**树节点有子节点状态值*/
	public static final String HASCHILD = "1";
	
	/**树节点无子节点状态值*/
	public static final String NOCHILD = "0";

	/**
	 * 新增节点
	 *
	 * @param stProblemTaskAssin
	 */
	void addStProblemTaskAssin(StProblemTaskAssin stProblemTaskAssin);
	
	/**
   * 修改节点
   *
   * @param stProblemTaskAssin
   * @throws JeecgBootException
   */
	void updateStProblemTaskAssin(StProblemTaskAssin stProblemTaskAssin) throws JeecgBootException;
	
	/**
	 * 删除节点
	 *
	 * @param id
   * @throws JeecgBootException
	 */
	void deleteStProblemTaskAssin(String id) throws JeecgBootException;

	  /**
	   * 查询所有数据，无分页
	   *
	   * @param queryWrapper
	   * @return List<StProblemTaskAssin>
	   */
    List<StProblemTaskAssin> queryTreeListNoPage(QueryWrapper<StProblemTaskAssin> queryWrapper);

	/**
	 * 【vue3专用】根据父级编码加载分类字典的数据
	 *
	 * @param parentCode
	 * @return
	 */
	List<SelectTreeModel> queryListByCode(String parentCode);

	/**
	 * 【vue3专用】根据pid查询子节点集合
	 *
	 * @param pid
	 * @return
	 */
	List<SelectTreeModel> queryListByPid(String pid);

    void batchEditFp(BatchFpVo batchFpVo);
    /**从问题库导入**/
	void importProblemAssin(List<Serializable> ids);

	void projectImport(ProjectImportAssinVo projectImportAssinVo);

	List<Map<String,Object>> statProblemLevel();

}
